const path = require('path');
require('dotenv').config();

module.exports = {
  development: {
    client: 'mysql2',
    useNullAsDefault: true,
    connection: {
      host: process.env.DB_MASTER_HOST,
      user: process.env.DB_MASTER_USER,
      password: process.env.DB_MASTER_PASS,
      database: process.env.DB_MASTER_NAME,
    },
    pool: { min: 0, max: 1 },
    migrations: {
      directory: path.join(__dirname, 'src/database/migrations/'),
    },
    seeds: {
      directory: path.join(__dirname, 'src/database/seeds/'),
    },
  },

  staging: {},

  production: {},
}['development'];
