import { Express } from 'express';
import knexConfig from '@config/knex.config';
import { limiterConfig } from '@config/limiter.config';
import { corsConfig } from '@config/cors.config';
import { compressionConfig } from '@config/compression.config';
import bullBoardConfig from '@config/bull-board.config';
import statusMonitorConfig from '@config/status-monitor.config';
import { errorHandlerConfig } from '@config/error-handler.config';
import { securityConfig } from '@config/security.config';
import expressConfig from '@config/express.config';
export const buildApp = function (app: Express) {
  knexConfig();
  limiterConfig(app);
  corsConfig(app);
  compressionConfig(app);
  bullBoardConfig(app);
  expressConfig(app);
  statusMonitorConfig(app);
  errorHandlerConfig(app);
  securityConfig(app);
};
