import Container from 'typedi';
import { Controller } from '@decorators/controller.decorator';
import { ValidateBody } from '@decorators/validate.decorator';
import { SuccessResponse } from '@decorators/success-response.decorator';
import { UserService } from '@services/user.service';
import { SendOtpRequest } from './requests/send-otp.request';
import { SendOtpResponse } from './responses/send-otp.response';

@Controller()
export class AuthController {
  @SuccessResponse()
  @ValidateBody(SendOtpRequest)
  async sendOtp(sendOtpRequest: SendOtpRequest) {
    const data = await Container.get(UserService).sendOtp(sendOtpRequest.mobile);
    return SendOtpResponse.map(data);
  }
}
