import { UserSource } from '@utils/constant/user.constant';
import { IsEnum, IsOptional, IsString } from 'class-validator';

export class UserRequest {
  @IsOptional()
  id: number;

  @IsString()
  name: string;

  @IsString()
  mobile: string;

  @IsString()
  gender: string;

  @IsString()
  age: string;

  @IsString()
  customer_id: string;

  @IsEnum(UserSource)
  source: string;
}
