import { User } from '@utils/interfaces/user.interface';

export class UserResponse {
  id: number;
  name: string;
  gender: string;
  mobile: string;
  age: string;
  cc: number;
  level: number;
  xp: number;
  source: string;
  is_app_user: string;
  customer_id: string;

  static map(userDto: User): UserResponse {
    if (!userDto) {
      return null;
    }
    const entity = new UserResponse();
    entity.id = userDto.id;
    entity.name = userDto.name;
    entity.gender = userDto.gender;
    entity.age = userDto.age;
    entity.cc = userDto.cc;
    entity.level = userDto.level;
    entity.xp = userDto.xp;
    entity.mobile = userDto.mobile;
    entity.source = userDto.source;
    entity.is_app_user = userDto.is_app_user;
    entity.customer_id = userDto.customer_id;
    return entity;
  }

  static mapMany(rows: User[]) {
    const result: any[] = [];
    rows.forEach(row => {
      result.push(this.map(row));
    });
    return result;
  }
}
