import { Container } from 'typedi';
import { Controller } from '@decorators/controller.decorator';
import { SuccessResponse } from '@decorators/success-response.decorator';
import { UserService } from '@services/user.service';
import { ValidateBody } from '@decorators/validate.decorator';
import { User } from '@utils/interfaces/user.interface';
import { UserRequest } from './requests/user.request';
import { UserResponse } from './responses/user.response';

@Controller()
@SuccessResponse()
export class UserController {
  @ValidateBody(UserRequest)
  async create(userRequest: UserRequest) {
    const user: User = await Container.get(UserService).createOrUpdateUser(userRequest);
    console.log(user);
    return UserResponse.map(user);
  }
}
