/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable @typescript-eslint/no-non-null-assertion */
import { ErrorHandler } from '@utils/class/error-handler.utils';
import 'reflect-metadata';
export const Controller = (): any => {
  return (target: any, propertyKey: string, descriptor: any) => {
    // Iterate over class properties except constructor
    for (const propertyName of Reflect.ownKeys(target.prototype).filter(prop => prop !== 'constructor')) {
      const desc = Object.getOwnPropertyDescriptor(target.prototype, propertyName)!;
      const isMethod = desc.value instanceof Function;
      if (!isMethod) continue;
      const fn = desc.value!;
      desc.value = async function DescriptorValue(...args: any[]) {
        try {
          const [req, res, next] = args;
          res['originalUrl'] = req.originalUrl;
          return await fn.apply(this, args);
        } catch (error) {
          const [res, req, next] = args;
          return ErrorHandler.handle(error, res, req, next);
        }
      };
      Object.defineProperty(target.prototype, propertyName, desc);
    }
  };
};
