import { ErrorData } from '@utils/interfaces/error/error-data.interface';
import { Request, Response } from 'express';

export class ErrorHandler {
  public static handle(err: any, req: Request, res: Response, next: any = null) {
    if (!err) {
      next();
    }
    let message: any = err.message;
    console.log(err);
    err.statusCode = err.statusCode || 500;
    if (err.statusCode >= 500) {
      message = 'Server Error, Please contact tech team';
    }
    err.status = err.status || 'error';
    const errData: ErrorData = {
      status: err.status,
      error: err,
      message: message,
      stack: '',
      info: '',
    };

    if (process.env.STACK_ENABLED == 'true') {
      errData.stack = err.stack;
    }
    console.log(errData);
    return res.status(err.statusCode).json(errData);
  }
}
