import AppError from '@utils/class/app-error.utils';
import { GridKey } from '@utils/interfaces/base/grid-key.interface';

export function mapWithObject(results: any) {
  return results.map((v: any) => Object.assign({}, v));
}

export function formatDate(date: Date) {
  let hours = date.getHours();
  let minutes = date.getMinutes().toString();
  const ampm = hours >= 12 ? 'pm' : 'am';
  hours = hours % 12;
  hours = hours ? hours : 12; // the hour '0' should be '12'
  minutes = parseInt(minutes) < 10 ? '0' + minutes : minutes;
  const strTime = hours + ':' + minutes + ' ' + ampm;
  return date.getMonth() + 1 + '/' + date.getDate() + '/' + date.getFullYear() + '  ' + strTime;
}

export function json2array(json: any) {
  if (!json) {
    return [];
  }
  const result: any[] = [];
  const keys = Object.keys(json);
  keys.forEach(function (key) {
    result.push(json[key]);
  });
  return result;
}

export function array2json(array: any[], key: string) {
  const result: any = {};
  array.forEach(function (item) {
    result[item[key]] = item;
  });
  return result;
}

export function getSelectIndex(assignedKeys: GridKey[]) {
  let selectIndex = '';
  assignedKeys.forEach((assignedKey: GridKey) => {
    selectIndex += selectIndex != '' ? ',' : '';
    selectIndex += assignedKey.dataIndex + ' as ' + assignedKey.dataIndex;
  });
  return selectIndex;
}

export function getArrayFromObject(objects: any[], key: string) {
  const result: string[] = [];
  objects.forEach((object: any) => {
    result.push(object[key]);
  });
  return result;
}

export function convertToSlug(text: string) {
  return text
    .toLowerCase()
    .replace(/ /g, '-')
    .replace(/[^\w-]+/g, '');
}

export function mobileSanity(mobile: string) {
  const str = mobile;
  const cc = str.split(str.slice(-10))[0];
  if (cc != '+91') {
    const mob = str.slice(-10);
    mobile = '+91'.concat(mob);
    return mobile;
  }
  return mobile;
}

export function getNumberOrZero(value: any) {
  return Number(value) || 0;
}
export function genderCheck(gender: string) {
  if (gender == 'Male' || 'Female' || 'Others') {
    return gender;
  } else {
    new AppError(406, 'gender not right', 'enter valid gender');
  }
}
