import { Express } from 'express';
const { ExpressAdapter } = require('@bull-board/express');
const { createBullBoard } = require('@bull-board/api');
import basicAuth from 'express-basic-auth';

export default function bullBoardConfig(app: Express) {
  const serverAdapter = new ExpressAdapter();
  serverAdapter.setBasePath('/queues');
  createBullBoard({
    queues: [],
    serverAdapter: serverAdapter,
  });
  const password = process.env.BULL_BOARD_PASSWORD || 'supersecret';

  app.use(
    '/queues',
    basicAuth({
      users: { admin: password },
      challenge: true,
    }),
  );
  app.use('/queues', serverAdapter.getRouter());
}
