import { Express } from 'express';
import rateLimit from 'express-rate-limit';

const rateWindowSize: number = process.env.RATE_WINDOW_SIZE || 15;
const limiter = rateLimit({
  windowMs: rateWindowSize * 60 * 1000, // 15 minutes
  max: process.env.RATE_LIMITER || 100, // limit each IP to 100 requests per windowMs
});

export const limiterConfig = function (app: Express) {
  if (process.env.NODE_ENV == 'production') {
    app.use(limiter);
  }
};
