import nodemailer from 'nodemailer';

const testConfig = {
  service: process.env.TEST_MAIL_SERVICE,
  auth: {
    user: process.env.TEST_MAIL_FROM_ADDRESS,
    pass: process.env.TEST_MAIL_PASSWORD,
  },
};

const productionConfig = {
  host: process.env.MAIL_HOST,
  port: process.env.MAIL_PORT,
  secure: process.env.MAIL_SECURE,
  requireTLS: process.env.MAIL_REQUIRE_TLS,
  auth: {
    user: process.env.MAIL_USERNAME,
    pass: process.env.MAIL_PASSWORD,
  },
};

const currentConfig: any = process.env.NODE_ENV == 'development' ? testConfig : productionConfig;

export const transporter = nodemailer.createTransport(currentConfig);
