exports.up = function (knex) {
  return knex.schema.createTable('users', table => {
    table.bigIncrements('id').primary().unsigned();
    table.string('name').notNullable();
    table.string('gender').notNullable();
    table.string('mobile').notNullable();
    table.integer('age').nullable();
    table.integer('otp').nullable();
    table.boolean('status').notNullable();
    table.timestamp('created_at').defaultTo(knex.raw('CURRENT_TIMESTAMP'));
    table.timestamp('updated_at').defaultTo(knex.raw('CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'));
  });
};
exports.down = function (knex) {
  return knex.schema.dropTable('users');
};
